import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;
import java.util.ListIterator;
/**
 * Write a description of class Spider here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Spider extends Enemys implements Freezeable //implements Killable
{
    /**
     * Act - do whatever the Spider wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    private int laydistance_ = 5;
    private int speed_= 2;
    private int speedY_ = (int)(Math.random()*5)-1;
    private final int direction_ = 4;
    private int reset_;
    private int backTrack_;
    private int freezecount = 0;
    private int life_ = 1;
    private boolean invincibility_ = false;
    private int timer_;
    private boolean alive_ = true;
    private boolean animate_ = false;;
    private int animatecounter_ = 12;

    public Spider()
    {
      super();  
      reset_ = 0;
      backTrack_= 0;
    }
     
        
        
    public void act() 
    {
            
        World w = getWorld(); //note has to be remade for each box
        Actor spider = getOneIntersectingObject(Man.class);//kill only the man
        if(freezecount == 0)
        {
            speed_ = speed_;
            
        }
        else
        {
            speed_= speed_/2;
            freezecount--;
        }
        
        if(spider != null)//collide
        {
          List<Killable> range = getObjectsInRange(getImage().getWidth(),Killable.class);
         for(int n = 0; n < range.size(); n++) // if in the same spot they meet
         {
            Killable k = range.get(n);
            k.dieBu();//actiavates the killable class << needs to be called in classes
         }
        }
        /*    
           if(canHatch())
        {
            dropEgg();
        }
          */ //replaced by the loop
        if (canMove(speed_,speedY_))
        {
          move(speed_,speedY_);
          reset_++;
          backTrack_++;//moving backwards
          if(reset_ > direction_)
          {
              reset_ = 0;
              speedY_= (int)(Math.random()*5)-1;
              
          }
          
        }
        else if(backTrack_ > 160)//bounce back givs extra time to lay eggs
        {
            turn(180);
            speed_ *= -1;
            getImage().mirrorVertically();
            backTrack_=0;
            
        }
        else
        {
            alive_ = false;//the cure goes here
            w.removeObject(this); // note greenfoot < getworld , was where strange error was occuring
        }
       
       while(1 ==(int)(Math.random()*400)+1)//400 since it seems any lower would be too much spawn rate
       {
            if(alive_)//hoorah. strange error has been fixed - alive false must be called when spider kills itself when OB
            
            {
                Egg e = new Egg();
                int x = getX() - getImage().getWidth()/2 ;
                int y = getY();
                w.addObject(e,x,y);
            
            }
       }  
       
       if(invincibility_)
       {
            timer_++;
            if(timer_ == 10)    
            {
                
                timer_ = 0;
                
                invincibility_ = false;
            }
       }
       
       if(animate_)
       {
            animatecounter_--;
               if(animatecounter_ == 0)
            {
               setImage("spider.png");
               animate_ = false;
               
            }
           
       }
     
    }
    
        public boolean canMove(int dx,int dy)
        {
            int x = getX();
            int y = getY();
            World w = getWorld();//where you can go and where you can't - min to max
            return (dx + x >= 0) && (dx + x < w.getWidth()) && (dy+y >= 0) && (dy+y < w.getHeight());//border
        }
        
        
        public void move(int dx,int dy)
        {
            int x = getX();
            int y = getY();
            setLocation(x+dx,y+dy);//move by this
        }
      
        
        public void freeze(int speed)
        {
            speed = speed_;
            speed_= speed_/2;
        }
        
         public void hp()
        {
            if(!invincibility_)
            {
                invincibility_ = true;
                setImage("spiderhit.gif");
                animate_ = true;
                if (life_ == 0)
                {
                   World w = getWorld();
                   w.removeObject(this);
                        
                }
                else
                {
                  life_--;//note -placing seperate made it call multiple times before incincible
                }
            }
        }
        
        
    }
